'use strict'

path     = require 'path'
debug    = require('debug')('jawbone:app')
express  = require 'express'

## config ##
process.env.PORT ||= 3000


## express modules
cookieParser = require 'cookie-parser'
session      = require 'express-session'
bodyParser   = require 'body-parser'


## setup server ##
module.exports = app = express()
app.disable 'x-powered-by'
app.set 'view engine', 'jade'
app.use express.static path.resolve 'public'
app.use cookieParser()
app.use bodyParser.urlencoded(extended: true)
app.use bodyParser.json()

http = require('http').Server(app)

app.use session
  secret: (process.env.SESSION_SECRET or 'うどん居酒屋 かずどん')

## load controllers, models, socket.io ##
components =
  models:      [  ]
  controllers: [ 'auth', 'main' ]

for type, items of components
  for item in items
    debug "load #{type}/#{item}"
    require(path.resolve type, item)(app)

## start server ##
http.listen process.env.PORT, ->
  debug "server start - port:#{process.env.PORT}"

