debug     = require('debug')('jawbone:controller:auth')
jawboneUp = require 'jawbone-up'

module.exports = (app) ->

  OAuth2  = require('simple-oauth2')(
    clientID:     process.env.CLIENT_ID
    clientSecret: process.env.APP_SECRET
    site:         'https://jawbone.com'
    tokenPath:    '/auth/oauth2/token'
    authorizationPath: '/auth/oauth2/auth'
  )


  ## OAuth2認証を開始
  app.get '/login', (req, res) ->
    app_root = "#{req.protocol}://#{req.headers.host}"
    auth_url = OAuth2.AuthCode.authorizeURL {
      redirect_uri: "#{app_root}/auth"
      scope: 'basic_read extended_read mood_read \
              move_read sleep_read generic_event_read'
    }
    return res.redirect auth_url


  ## jawbone.comからのコールバックを受ける
  app.get '/auth', (req, res) ->
    unless code = req.query.code
      return res.redirect '/'

    app_root = "#{req.protocol}://#{req.headers.host}"
    OAuth2.AuthCode.getToken {
      redirect_uri: "#{app_root}/auth"
      code: code
    }, (token_err, token_res) ->
      return res.redirect '/' if token_err

      ## Access Tokenを取得、sessionに保存
      token = OAuth2.AccessToken.create(token_res)
              .token.access_token
      debug "AccessToken : #{token}"  # tokenを出力

      up = jawboneUp
        access_token:  token
        client_secret: process.env.CLIENT_ID

      ## ユーザー情報を取得し、sessionに保存
      up.me.get {}, (up_err, up_res) ->
        if up_err
          debug up_err
          return res.redirect '/'
        try
          up_res = JSON.parse up_res
        catch err
          debug err
          return res.redirect '/'

        req.session.jawbone_token = token
        req.session.fullname = "#{up_res.data.first} #{up_res.data.last}"
        req.session.icon  = "https://jawbone.com/#{up_res.data.image}"
        return res.redirect '/'


  ## ログアウト処理
  app.get '/logout', (req, res) ->
    req.session.destroy()
    res.redirect '/'
