debug     = require('debug')('jawbone:controller:main')
jawboneUp = require 'jawbone-up'

module.exports = (app) ->

  app.get '/', (req, res) ->
    args =
      user:
        is_login: false

    unless req.session.jawbone_token?
      return res.render 'index', args

    args.user =
      is_login: true
      fullname: req.session.fullname
      icon: req.session.icon

    return res.render 'index', args


  app.get '/sleeps.json', (req, res) ->

    res.set 'Content-Type', 'application/json; charset=utf-8'

    unless req.session.jawbone_token?
      res.status(401).send
        error: "Unauthorized"
      return
    
    up = jawboneUp
      access_token:  req.session.jawbone_token
      client_secret: process.env.CLIENT_ID

    debug "get sleep API"
    up.sleeps.get {}, (up_err, up_res) ->
      if up_err
        res.status(500).send
          error: up_err
        return

      data = JSON.parse up_res
      res.send data
