# Description:
#   俺APIのstatus.jsonを使って、起きているか確認する
#
# Commands:
#   hubot [SCREEN_NAME] (起きてる|寝てる)？
#
# Author:
#   @shokai

module.exports = (robot) ->
  robot.respond /([a-z\d_\-]+) (起きて|寝て)る.*/i
  , (msg) ->
    from = msg.message.user.name
    who = msg.match[1]
    api_url = "https://ore-api.herokuapp.com"
    url = "#{api_url}/#{who}/status.json"

    robot.http(url).get() (err, res, body) ->
      return if err
      data = JSON.parse body

      status = switch data.status
        when "up"   then "起きてる"
        when "down" then "寝てるかもしれない"
        else "わからない (#{data.status})"

      msg.send "@#{from} #{who}、#{status}"
