# Description:
#   俺APIを使って、起床を通知
#   あらかじめ指定しておいたチャットルームに通知を飛ばす
#
# Author:
#   @shokai

module.exports = (robot) ->

  api_url = "https://ore-api.herokuapp.com"
  socket = require('socket.io-client').connect api_url
  channel = "#general"  # 通知先のチャットルーム

  ## 俺APIからの通知を受け取る
  socket.on 'sleep', (e) ->
    return if e.action isnt 'creation'
    robot.send channel
    , "@#{e.screen_name} が眠りから覚めました"

    get_sleep e.screen_name, e.event_xid
    , (err, sleep) ->
      return if err
      
      txt = "睡眠時間 #{sleep.title}\n"
      if sleep.details.awakenings > 1
        n = sleep.details.awakenings
        txt += "#{n}回の二度寝からがんばって起きました"

      robot.send channel, txt

  ## 睡眠の詳細を取得
  get_sleep = (who, xid, callback = ->) ->
    url = "#{api_url}/#{who}/sleeps.json?xid=#{xid}"
    robot.http(url).get() (err, res, body) ->
      return callback err if err
      data = JSON.parse body
      callback null, data.data
